
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payment_iconsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_icons = await db.payment_icons.create(
            {
                id: data.id || undefined,
        
        method: data.method
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await payment_icons.setFooter( data.footer || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.payment_icons.getTableName(),
                belongsToColumn: 'icon_image',
                belongsToId: payment_icons.id,
            },
            data.icon_image,
            options,
        );
        

        return payment_icons;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const payment_iconsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                method: item.method
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const payment_icons = await db.payment_icons.bulkCreate(payment_iconsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < payment_icons.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.payment_icons.getTableName(),
                    belongsToColumn: 'icon_image',
                    belongsToId: payment_icons[i].id,
                },
                data[i].icon_image,
                options,
            );
        }
        

        return payment_icons;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const payment_icons = await db.payment_icons.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.method !== undefined) updatePayload.method = data.method;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await payment_icons.update(updatePayload, {transaction});

        
        
        if (data.footer !== undefined) {
            await payment_icons.setFooter(
              
              data.footer,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.payment_icons.getTableName(),
                belongsToColumn: 'icon_image',
                belongsToId: payment_icons.id,
            },
            data.icon_image,
            options,
        );
        

        return payment_icons;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_icons = await db.payment_icons.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of payment_icons) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of payment_icons) {
                await record.destroy({transaction});
            }
        });


        return payment_icons;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const payment_icons = await db.payment_icons.findByPk(id, options);

        await payment_icons.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await payment_icons.destroy({
            transaction
        });

        return payment_icons;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const payment_icons = await db.payment_icons.findOne(
            { where },
            { transaction },
        );

        if (!payment_icons) {
            return payment_icons;
        }

        const output = payment_icons.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.footer = await payment_icons.getFooter({
            transaction
        });
        
        
        output.icon_image = await payment_icons.getIcon_image({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.footer_settings,
        as: 'footer',
        
        where: filter.footer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.footer.split('|').map(term => Utils.uuid(term)) } },
            {
              copyright_text: {
                [Op.or]: filter.footer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'icon_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.method) {
                where = {
                    ...where,
                method: filter.method,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.payment_icons.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'payment_icons',
                        'method',
                        query,
                    ),
                ],
            };
        }

        const records = await db.payment_icons.findAll({
            attributes: [ 'id', 'method' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['method', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.method,
        }));
    }

    
};

